<%- include('../partials/header'); %>
<%- include('../partials/navbar'); %>
<%- include('../partials/scripts'); %>
<script>
    function updateAnswers() {
        var questions = [];
        for (let i = 0; i < $('#answersTable tr').length; i++) {
            $(`form#${i}`).submit(function (event) {
                event.preventDefault();
                var dataFromForm = $(`form#${i}`).serializeArray();
                var obj = {
                    answers: [],
                };
                for (let ii = 0; ii < dataFromForm.length; ii++) {
                    var name = dataFromForm[ii].name;
                    var value = dataFromForm[ii].value;
                    if (name === 'answer[]') {
                        obj.answers.push({
                            text: value,
                            correct: false,
                        });
                    } else if (name === 'correctAnswer[]') {
                        if (obj.answers.length > 0) {
                            obj.answers[obj.answers.length - 1].correct = true;
                            /*for (let iii = 0; iii < obj.answers.length; iii++) {
                                var answer = obj.answers[iii];
                                if (answer.text === value) {
                                    answer.correct = true;
                                }
                            }*/
                        }
                    } else {
                        obj[name] = value;
                    }
                }
                questions.push(obj);
            });
            $(`form#${i}`).submit();
        }
        console.log(questions);

        // send data to the server
        $.post({
            url: '/admin/questionSets/edit/',
            data: {
                id: '<%= req.query.id %>',
                questions,
            },
            success: function (response) {
                console.log(response);
                if (response === 'ok') {
                    alert('Povedlo se!');
                    // window.location.href = '/admin/questionSets/edit?id=<%= req.query.id %>';
                }
            },
        }).fail(function () {
            alert('Chyba komunikace se serverem.');
        });
    }

    function newRow() {
        var id = $('td#answers').length;
        $('#answersTable').append(
            $("<tr>").append(
                $("<form method='POST' action=''>"),
                $("<td>").append(
                    $("<div>", { class: 'input-group' }).append(
                        $("<input>", { name: 'wording', type: 'text', class: 'form-control bg-light border-0', placeholder: 'Question wording' })
                    ),
                ),
                $("<td>").append(
                    $("<div>", { class: 'input-group' }).append(
                        $("<input>", { name: 'timeToAnswer', type: 'text', class: 'form-control bg-light border-0', placeholder: 'Time to answer' }),
                    ),
                ),
                $("<td>", { id: 'answers' }).append(
                    $("<div>", { class: 'input-group form-group' }).append(
                        $("<input>", { name: 'answer[]', type: 'text', class: 'form-control bg-light border-0', placeholder: 'Answer' }),
                        $('<div>', { class: 'input-group-append' }).append(
                            $('<div>', { class: 'input-group-text bg-light border-0' }).append(
                                $('<div>', { class: 'custom-control custom-checkbox' }).append(
                                    $('<input>', { name: 'correctAnswer[]', type: 'checkbox', class: 'custom-control-input', id: `correct-checkbox-${id}` }),
                                    $('<label>', { for: `correct-checkbox-${id}`, class: 'custom-control-label' }).text('Correct'),
                                ),
                            ),
                            $('<button>', { class: 'btn-remove-anser-input btn btn-danger', type: 'button', onclick: '$(this).parent().parent().remove();' }).text('X'),
                        ),
                    ),
                ),
                $('<td>').append(
                    $('<button>', { class: 'btn btn-primary', type: 'button', onclick: `newAnswer($(this).parent().parent().children("td#answers"));` }).append(
                        $('<i>', { class: 'fas fa-plus' }),
                    )
                ),
            ),
        );
    }

    function sendJson() {
        // send data to the server
        $.post({
            url: '/admin/questionSets/edit/',
            data: {
                id: '<%= req.query.id %>',
                questions: JSON.parse($("textarea#json").val()),
            },
            success: function (response) {
                console.log(response);
                if (response === 'ok') {
                    alert('Successfully updated questions!');
                    window.location.href = '/admin/questionSets/edit?id=<%= req.query.id %>';
                }
            },
        }).fail(function () {
            alert('Server communication error!');
        });
    }
</script>
<!-- Content Wrapper -->
<div id="content-wrapper" class="d-flex flex-column">
    <div id="content">
        <%- include('../partials/topbar') %>
        <!-- Begin Page Content -->
        <div class="container-fluid">
            <!-- Page Heading -->
            <div class="d-sm-flex align-items-center justify-content-between mb-4">
                <h1 class="h3 mb-0 text-gray-800"><%= title %></h1>
            </div>
            <!-- Content Row -->
            <div class="row">
                <!-- Area Chart -->
                <div class="col-xl-12">
                    <div class="card shadow mb-4">
                        <!-- Card Header - Dropdown -->
                        <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
                            <h6 class="m-0 font-weight-bold text-primary">Table of questions</h6>
                            <div class="dropdown no-arrow">
                                <a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink"
                                    data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                    <i class="fas fa-ellipsis-v fa-sm fa-fw text-gray-400"></i>
                                </a>
                                <div class="dropdown-menu dropdown-menu-right shadow animated--fade-in"
                                    aria-labelledby="dropdownMenuLink">
                                    <div class="dropdown-header">Dropdown Header:</div>
                                    <a class="dropdown-item" href="#">Action</a>
                                    <a class="dropdown-item" href="#">Another action</a>
                                    <div class="dropdown-divider"></div>
                                    <a class="dropdown-item" href="#">Something else here</a>
                                </div>
                            </div>
                        </div>
                        <!-- Card Body -->
                        <div class="card-body">
                            <table class="table table-bordered" id="answersTable" width="100%" cellspacing="0">
                                <thead>
                                    <tr>
                                        <th>Wording</th>
                                        <th>Time for answer</th>
                                        <th>Answers</th>
                                        <th>Actions</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <% questionSet.questions.forEach((question, i) => { %>
                                    <tr>
                                        <form action="" method="POST" id="<%= i %>">
                                            <td>
                                                <div class="input-group">
                                                    <input type="text" class="form-control bg-light border-0 "
                                                        name="wording" placeholder="Question wording"
                                                        value="<%= question.wording %>">
                                                </div>
                                            </td>
                                            <td>
                                                <div class="input-group">
                                                    <input type="text" class="form-control bg-light border-0 "
                                                        placeholder="Time to answer" name="timeToAnswer"
                                                        value="<%= question.timeToAnswer %>">
                                                </div>
                                            </td>
                                            <td id="answers">
                                                <% text = ''; question.answers.forEach((answer, ii) => {
                                                //text += `${answer.correct ?`<span style="color: green;">${answer.text}<!-- <i class="fas fa-check"></i>--></span>` : `<span style="color: red;">${answer.text}</span>`}${i == question.answers.length-1 ? '' : ', '}`;
                                                text += `<div id="answer-box-${answer._id}-${ii}" class="input-group form-group">
                                                    <input name="answer[]" type="text" value='${answer.text}' class="form-control bg-light border-0" placeholder="Answer" required>
                                                    <div class="input-group-append">
                                                        <div class="input-group-text bg-light border-0">
                                                            <div class="custom-control custom-checkbox ">
                                                                <input type="checkbox" class="custom-control-input" id="ok-answer-${answer._id}-${ii}" value='${answer.text}' name="correctAnswer[]" ${ answer.correct ? 'checked' : '' } >
                                                                <label class="custom-control-label" for="ok-answer-${answer._id}-${ii}" ${ answer.correct ? 'checked' : '' } >Correct</label>
                                                            </div>
                                                        </div>
                                                        <button class="btn-remove-answer-input btn btn-danger" type="button" onclick='$(this).parent().parent().remove();'>X</button>
                                                    </div>
                                                </div>`
                                            }); %>
                                                <%- text %>
                                            </td>
                                            <td>
                                                <button class="btn btn-primary" type="button"
                                                    onclick='newAnswer($(this).parent().parent().children("td#answers"));'>
                                                    <i class="fas fa-plus"></i> Answer
                                                </button>
                                            </td>
                                        </form>
                                    </tr>
                                    <% }); %>
                                </tbody>
                            </table>
                            <button class="btn btn-primary" type="button" onclick="updateAnswers();">
                                Submit
                                <i class="fas fa-arrow-circle-right"></i>
                            </button>
                            <button class="btn btn-primary" type="button" onclick="newRow();">
                                Add row
                                <i class="fas fa-plus-circle"></i>
                            </button>
                        </div>
                    </div>
                </div>
            </div>
            <!-- /.container-fluid -->
            <!-- Content Row -->
            <div class="row">
                <!-- Area Chart -->
                <div class="col-xl-12">
                    <div class="card shadow mb-4">
                        <!-- Card Header - Dropdown -->
                        <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
                            <h6 class="m-0 font-weight-bold text-primary">Import questions in JSON</h6>
                            <div class="dropdown no-arrow">
                                <a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink"
                                    data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                    <i class="fas fa-ellipsis-v fa-sm fa-fw text-gray-400"></i>
                                </a>
                                <div class="dropdown-menu dropdown-menu-right shadow animated--fade-in"
                                    aria-labelledby="dropdownMenuLink">
                                    <div class="dropdown-header">Dropdown Header:</div>
                                    <a class="dropdown-item" href="#">Action</a>
                                    <a class="dropdown-item" href="#">Another action</a>
                                    <div class="dropdown-divider"></div>
                                    <a class="dropdown-item" href="#">Something else here</a>
                                </div>
                            </div>
                        </div>
                        <!-- Card Body -->
                        <div class="card-body">
                            <div class="row">
                                <div class="col-sm-12">
                                    <div class="input-group">
                                        <textarea class="form-control" id="json" cols="30" rows="10" placeholder='Insert JSON here. Example:
[{
    "wording": String,
    "timeToAnswer": Number,
    "answers": [{
        "text": String,
        "correct": Boolean
    }]
}]'></textarea>
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-sm-12">
                                    <br>
                                    <button class="btn btn-primary" type="button" onclick="sendJson();">
                                        Submit
                                        <i class="fas fa-arrow-circle-right"></i>
                                    </button>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <!-- /.container-fluid -->
        </div>
    </div>

    <% include('../partials/footer'); %>
    <script>
        // add new input
        function newAnswer(objectOfTd) {
            var id = objectOfTd.children('div').length;
            objectOfTd.append(
                $("<div>", { class: 'input-group form-group' }).append(
                    $("<input>", { name: 'answer[]', placeholder: 'Answer', type: 'text', class: 'form-control bg-light border-0' }),
                    $('<div>', { class: 'input-group-append' }).append(
                        $('<div>', { class: 'input-group-text bg-light border-0' }).append(
                            $('<div>', { class: 'custom-control custom-checkbox' }).append(
                                $('<input>', { name: 'correctAnswer[]', type: 'checkbox', class: 'custom-control-input', id: `correct-checkbox-${id}` }),
                                $('<label>', { for: `correct-checkbox-${id}`, class: 'custom-control-label' }).text('Correct'),
                            ),
                        ),
                        $('<button>', { class: 'btn-remove-anser-input btn btn-danger', type: 'button', onclick: '$(this).parent().parent().remove();' }).text('X'),
                    ),
                ),
            );
        }
    </script>
    </body>

    </html>